import { jsx as _jsx } from "react/jsx-runtime";
import { memo } from "react";
import { tss } from "../tss";
export var GlCard = memo(function (props) {
    var children = props.children, link = props.link, className = props.className;
    var _a = useStyles({ "isLink": link !== undefined }), classes = _a.classes, cx = _a.cx;
    var onClick = (function () {
        if (link === undefined) {
            return undefined;
        }
        return function () { return window.open(link.href, "_blank"); };
    })();
    return (_jsx("div", { className: cx(classes.root, className), onClick: onClick, children: children }));
});
var useStyles = tss
    .withName({ GlCard: GlCard })
    .withParams()
    .create(function (_a) {
    var theme = _a.theme, isLink = _a.isLink;
    return ({
        "root": {
            "borderRadius": 16,
            "transition": "box-shadow 200ms",
            "margin": theme.spacing(2),
            "boxShadow": theme.shadows[1],
            "backgroundColor": theme.colors.useCases.surfaces.surface1,
            "cursor": isLink ? "pointer" : undefined,
            ":hover": {
                "boxShadow": theme.shadows[2],
            },
        },
    });
});
//# sourceMappingURL=GlCard.js.map