var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
/* eslint-disable @typescript-eslint/no-namespace */
import { memo, useEffect, useState } from "react";
import { Button } from "onyxia-ui/Button";
import { tss } from "../tss";
import { Text } from "onyxia-ui/Text";
import { GlCard } from "./GlCard";
import { breakpointsValues } from "../theme";
import { useDomRect } from "powerhooks/useDomRect";
export var GlProjectCard = memo(function (props) {
    var className = props.className, text = props.text, projectImageUrl = props.projectImageUrl, subtitle = props.subtitle, title = props.title, badgeLabel = props.badgeLabel, link = props.link, badgeBackgroundColor = props.badgeBackgroundColor, badgeColor = props.badgeColor;
    var _a = __read(useState(undefined), 2), imgAspectRatio = _a[0], setImgAspectRatio = _a[1];
    var _b = useDomRect(), headerRef = _b.ref, headerWidth = _b.domRect.width;
    var img = new Image();
    useEffect(function () {
        img.src = projectImageUrl;
        img.onload = function () {
            setImgAspectRatio(img.height / img.width);
        };
    }, [projectImageUrl]);
    var _c = useStyles({
        badgeColor: badgeColor,
        badgeBackgroundColor: badgeBackgroundColor,
        projectImageUrl: projectImageUrl,
        headerWidth: headerWidth,
        imgAspectRatio: imgAspectRatio,
        "classesOverrides": props.classes,
    }), classes = _c.classes, cx = _c.cx;
    return (_jsxs(GlCard, { link: link, className: cx(classes.root, className), children: [_jsx("div", { ref: headerRef, className: classes.header, children: badgeLabel !== undefined && (_jsx(Button, { type: "submit", className: classes.button, variant: "ternary", href: link === null || link === void 0 ? void 0 : link.href, onClick: link === null || link === void 0 ? void 0 : link.onClick, children: badgeLabel })) }), _jsxs("div", { className: classes.footer, children: [_jsx(Text, { typo: "object heading", className: classes.footerTitle, children: title }), subtitle !== undefined && (_jsx(Text, { typo: "label 2", className: classes.footerSubtitle, children: subtitle })), text !== undefined && (_jsx(Text, { className: classes.footerText, typo: "label 2", children: text }))] })] }));
});
var useStyles = tss
    .withName({ GlProjectCard: GlProjectCard })
    .withParams()
    .create(function (_a) {
    var theme = _a.theme, badgeBackgroundColor = _a.badgeBackgroundColor, badgeColor = _a.badgeColor, projectImageUrl = _a.projectImageUrl, headerWidth = _a.headerWidth, imgAspectRatio = _a.imgAspectRatio;
    return ({
        "root": {
            "transition": "opacity 300ms",
            "opacity": headerWidth === 0 || imgAspectRatio === undefined ? 0 : 1,
            "display": "flex",
            "flexDirection": "column",
            "overflow": "hidden",
            "margin": (function () {
                if (theme.windowInnerWidth >= breakpointsValues.lg) {
                    return undefined;
                }
                return theme.spacing(1);
            })(),
        },
        "footer": {
            "flex": 1,
            "backgroundColor": theme.isDarkModeEnabled
                ? theme.colors.palette.dark.greyVariant1
                : theme.colors.palette.light.light,
            "padding": [4, 5, 4, 5]
                .map(function (spacing) { return "".concat(theme.spacing(spacing), "px"); })
                .join(" "),
        },
        "footerTitle": {
            "marginBottom": theme.spacing(1),
        },
        "footerSubtitle": {
            "marginBottom": theme.spacing(1),
        },
        "header": {
            "width": "100%",
            "margin": 0,
            "background": "url(\"".concat(projectImageUrl, "\")"),
            "minHeight": imgAspectRatio === undefined
                ? undefined
                : headerWidth * imgAspectRatio,
            "backgroundSize": "cover",
            "backgroundPosition": "center",
            "display": "flex",
            "justifyContent": "flex-end",
            "alignItems": "flex-start",
            "padding": theme.spacing(3),
        },
        "button": {
            "marinLeft": theme.spacing(7),
            "border": "none",
            "backgroundColor": badgeBackgroundColor !== null && badgeBackgroundColor !== void 0 ? badgeBackgroundColor : undefined,
            "color": (function () {
                if (badgeColor !== undefined) {
                    return "".concat(badgeColor, " !important");
                }
                return undefined;
            })(),
        },
        "footerText": {},
    });
});
//# sourceMappingURL=GlProjectCard.js.map