import { type IconProps } from "onyxia-ui/Icon";
import { useTheme } from "./theme";
export type GlCheckListProps = {
    className?: string;
    hasAnimation?: boolean;
    classes?: Partial<ReturnType<typeof useStyles>["classes"]>;
    heading?: string;
    subHeading?: string;
    setIconColor?: (colors: ReturnType<typeof useTheme>["colors"]) => {
        iconColor: string;
    };
    icon?: IconProps.Icon;
    elements?: {
        title?: string;
        description?: string;
        iconOverride?: IconProps.Icon;
        setIconColorOverride?: GlCheckListProps["setIconColor"];
        isIconHidden?: boolean;
    }[];
};
export declare const GlCheckList: import("react").MemoExoticComponent<(props: GlCheckListProps) => import("react/jsx-runtime").JSX.Element>;
declare const useStyles: import("tss-react").Tss.UseStyles<{
    theme: {
        paddingRightLeft: number;
        customShadow: string;
        borderRadius: number;
        isDarkModeEnabled: boolean;
        colors: {
            palette: {
                focus: {
                    main: string;
                    light: string;
                    light2: string;
                };
                dark: {
                    main: string;
                    light: string;
                    greyVariant1: string;
                    greyVariant2: string;
                    greyVariant3: string;
                    greyVariant4: string;
                };
                light: {
                    main: string;
                    light: string;
                    greyVariant1: string;
                    greyVariant2: string;
                    greyVariant3: string;
                    greyVariant4: string;
                };
                redError: {
                    main: string;
                    light: string;
                };
                greenSuccess: {
                    main: string;
                    light: string;
                };
                orangeWarning: {
                    main: string;
                    light: string;
                };
                blueInfo: {
                    main: string;
                    light: string;
                };
            };
            useCases: {
                typography: {
                    textPrimary: string;
                    textSecondary: string;
                    textTertiary: string;
                    textDisabled: string;
                    textFocus: string;
                };
                buttons: {
                    actionHoverPrimary: string;
                    actionHoverSecondary: string;
                    actionHoverTernary: string;
                    actionSelected: string;
                    actionActive: string;
                    actionDisabled: string;
                    actionDisabledBackground: string;
                };
                surfaces: {
                    background: string;
                    surface1: string;
                    surface2: string;
                };
                alertSeverity: {
                    error: {
                        main: string;
                        background: string;
                    };
                    success: {
                        main: string;
                        background: string;
                    };
                    warning: {
                        main: string;
                        background: string;
                    };
                    info: {
                        main: string;
                        background: string;
                    };
                };
            };
            getUseCases: (params: {
                isDarkModeEnabled: boolean;
            }) => {
                typography: {
                    textPrimary: string;
                    textSecondary: string;
                    textTertiary: string;
                    textDisabled: string;
                    textFocus: string;
                };
                buttons: {
                    actionHoverPrimary: string;
                    actionHoverSecondary: string;
                    actionHoverTernary: string;
                    actionSelected: string;
                    actionActive: string;
                    actionDisabled: string;
                    actionDisabledBackground: string;
                };
                surfaces: {
                    background: string;
                    surface1: string;
                    surface2: string;
                };
                alertSeverity: {
                    error: {
                        main: string;
                        background: string;
                    };
                    success: {
                        main: string;
                        background: string;
                    };
                    warning: {
                        main: string;
                        background: string;
                    };
                    info: {
                        main: string;
                        background: string;
                    };
                };
            };
        };
        typography: import("onyxia-ui").ComputedTypography<never>;
        shadows: typeof import("onyxia-ui/lib/shadows").shadows;
        spacing: import("onyxia-ui").Spacing;
        muiTheme: import("@mui/material").Theme;
        iconSizesInPxByName: Record<import("onyxia-ui").IconSizeName, number>;
        windowInnerWidth: number;
    };
}, Record<never, unknown>, "element" | "heading" | "root" | "elements" | "subHeading" | "headingWrapper" | "checkIconWrapper" | "checkIcon" | "elementTitleAndDescriptionWrapper" | "elementTitle" | "elementDescription", Record<string, unknown>>;
export {};
