import type { GlHeaderLinkProps } from "./GlHeaderLink";
export type GlHeaderLinksProps = GlHeaderLinksProps.LargeScreen | GlHeaderLinksProps.SmallScreen;
declare namespace GlHeaderLinksProps {
    type LargeScreen = {
        type: "largeScreen";
        className?: string;
        classes?: Partial<ReturnType<typeof useStyles>["classes"]>;
        links: GlHeaderLinkProps[];
    };
    type SmallScreen = {
        type: "smallScreen";
        isUnfolded: boolean;
    } & Omit<LargeScreen, "type">;
}
export declare const GlHeaderLinks: import("react").MemoExoticComponent<(props: GlHeaderLinksProps) => import("react/jsx-runtime").JSX.Element>;
declare const useStyles: import("tss-react").Tss.UseStyles<{
    theme: {
        paddingRightLeft: number;
        customShadow: string;
        borderRadius: number;
        isDarkModeEnabled: boolean;
        colors: {
            palette: {
                focus: {
                    main: string;
                    light: string;
                    light2: string;
                };
                dark: {
                    main: string;
                    light: string;
                    greyVariant1: string;
                    greyVariant2: string;
                    greyVariant3: string;
                    greyVariant4: string;
                };
                light: {
                    main: string;
                    light: string;
                    greyVariant1: string;
                    greyVariant2: string;
                    greyVariant3: string;
                    greyVariant4: string;
                };
                redError: {
                    main: string;
                    light: string;
                };
                greenSuccess: {
                    main: string;
                    light: string;
                };
                orangeWarning: {
                    main: string;
                    light: string;
                };
                blueInfo: {
                    main: string;
                    light: string;
                };
            };
            useCases: {
                typography: {
                    textPrimary: string;
                    textSecondary: string;
                    textTertiary: string;
                    textDisabled: string;
                    textFocus: string;
                };
                buttons: {
                    actionHoverPrimary: string;
                    actionHoverSecondary: string;
                    actionHoverTernary: string;
                    actionSelected: string;
                    actionActive: string;
                    actionDisabled: string;
                    actionDisabledBackground: string;
                };
                surfaces: {
                    background: string;
                    surface1: string;
                    surface2: string;
                };
                alertSeverity: {
                    error: {
                        main: string;
                        background: string;
                    };
                    success: {
                        main: string;
                        background: string;
                    };
                    warning: {
                        main: string;
                        background: string;
                    };
                    info: {
                        main: string;
                        background: string;
                    };
                };
            };
            getUseCases: (params: {
                isDarkModeEnabled: boolean;
            }) => {
                typography: {
                    textPrimary: string;
                    textSecondary: string;
                    textTertiary: string;
                    textDisabled: string;
                    textFocus: string;
                };
                buttons: {
                    actionHoverPrimary: string;
                    actionHoverSecondary: string;
                    actionHoverTernary: string;
                    actionSelected: string;
                    actionActive: string;
                    actionDisabled: string;
                    actionDisabledBackground: string;
                };
                surfaces: {
                    background: string;
                    surface1: string;
                    surface2: string;
                };
                alertSeverity: {
                    error: {
                        main: string;
                        background: string;
                    };
                    success: {
                        main: string;
                        background: string;
                    };
                    warning: {
                        main: string;
                        background: string;
                    };
                    info: {
                        main: string;
                        background: string;
                    };
                };
            };
        };
        typography: import("onyxia-ui").ComputedTypography<never>;
        shadows: typeof import("onyxia-ui/lib/shadows").shadows;
        spacing: import("onyxia-ui").Spacing;
        muiTheme: import("@mui/material").Theme;
        iconSizesInPxByName: Record<import("onyxia-ui").IconSizeName, number>;
        windowInnerWidth: number;
    };
}, Pick<GlHeaderLinksProps, "type"> & {
    contentWrapperHeight: number;
    isUnfolded: boolean | undefined;
}, "overline" | "link" | "root" | "contentWrapper" | "linkRoot", Record<string, unknown>>;
export {};
