import type { Source } from "./Source";
export type IllustrationProps = IllustrationProps.Image | IllustrationProps.Video | IllustrationProps.CustomComponent;
declare namespace IllustrationProps {
    type Image = {
        type: "image";
        sources?: Source[];
        src: string;
        hasShadow?: boolean;
        hasBorderRadius?: boolean;
        alt?: string;
    };
    type Video = {
        type: "video";
        sources: Source[];
        hasShadow?: boolean;
        autoPlay?: boolean;
        delayBeforeAutoPlay?: number;
        muted?: boolean;
        loop?: boolean;
        controls?: boolean;
        hasBorderRadius?: boolean;
    };
    type CustomComponent = {
        type: "custom component";
        Component: (props: {
            className?: string;
            onLoad: () => void;
            id: string;
        }) => JSX.Element | null;
    };
}
export {};
